unit Mainmenu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, VBXCtrl, Crystal, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenReport1: TMenuItem;
    Close1: TMenuItem;
    PrinttoPrinter1: TMenuItem;
    PrinttoWindow1: TMenuItem;
    Export1: TMenuItem;
    Exit1: TMenuItem;
    Format1: TMenuItem;
    ReportTitle1: TMenuItem;
    Graphing1: TMenuItem;
    Sorting1: TMenuItem;
    RecordSortField1: TMenuItem;
    GroupSortField1: TMenuItem;
    Formula1: TMenuItem;
    Formula2: TMenuItem;
    SelectionFormula1: TMenuItem;
    GroupSelection1: TMenuItem;
    Database1: TMenuItem;
    Location1: TMenuItem;
    LogonInfo1: TMenuItem;
    AccessSecurity1: TMenuItem;
    SQL1: TMenuItem;
    ModifySQL1: TMenuItem;
    StoredProcedure1: TMenuItem;
    OpenDialog1: TOpenDialog;
    CrystalReport1: TCrystalReport;
    Print1: TMenuItem;
    OpenDialog2: TOpenDialog;
    ToList: TEdit;
    ToListLabel: TLabel;
    CCListLabel: TLabel;
    CCList: TEdit;
    Subject: TEdit;
    SubjectLabel: TLabel;
    EmailMessage: TEdit;
    EmailMessageLabel: TLabel;
    Done: TButton;
    N1: TMenuItem;
    N2: TMenuItem;
    PrinttoDiskFile1: TMenuItem;
    procedure OpenReport1Click(Sender: TObject);
    procedure PrinttoPrinter1Click(Sender: TObject);
    procedure PrinttoWindow1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Location1Click(Sender: TObject);
    procedure LogonInfo1Click(Sender: TObject);
    procedure SelectionFormula1Click(Sender: TObject);
    procedure GroupSelection1Click(Sender: TObject);
    procedure Formula2Click(Sender: TObject);
    procedure Export1Click(Sender: TObject);
    procedure DoneClick(Sender: TObject);
    procedure PrinttoDiskFile1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Count: Integer;
  Continue : Boolean;
  FormulaString, ReportSelection, GroupSelection : String;

implementation
 uses
 password;
{$R *.DFM}

procedure TForm1.OpenReport1Click(Sender: TObject);
begin
     opendialog1.execute;                        {Get the report filename from
                                                  user                        }
     CrystalReport1.ReportFileName := OpenDialog1.FileName;
end;

procedure TForm1.PrinttoPrinter1Click(Sender: TObject);
begin
     crystalreport1.destination := 1;            {set destination of the report
                                                  to printer                   }
     printtowindow1.checked := false;
     printtoprinter1.checked := true;            {show that Printer is checked}
     Export1.checked := false;
     PrinttoDiskFile1.checked := false;
end;

procedure TForm1.PrinttoWindow1Click(Sender: TObject);
begin
     crystalreport1.destination := 0;            {set destination of the report
                                                  to print to screen           }
     printtowindow1.checked := true;             {show that Window is checked}
     printtoprinter1.checked := false;
     Export1.checked := false;
     PrinttoDiskFile1.checked := false;
end;

procedure TForm1.PrinttoDiskFile1Click(Sender: TObject);
begin
     crystalreport1.destination := 2;            {set destination of the report
                                                  to disk file                 }
     printtowindow1.checked := false;
     printtoprinter1.checked := false;
     Export1.checked := false;
     PrinttoDiskFile1.checked := true;           {show that Printer is checked}
end;

procedure TForm1.Export1Click(Sender: TObject);
begin
     Export1.checked := true;                    {show that Export is checked}
     printtowindow1.checked := false;
     printtoprinter1.checked := false;
     PrinttoDiskFile1.checked := false;

     ToList.visible := True;                     {show all controls for Email}
     ToListLabel.visible := True;
     CCList.visible := True;
     CCListLabel.visible := True;
     Subject.visible := True;
     SubjectLabel.visible := True;
     EmailMessage.visible := True;
     EmailMessageLabel.visible := True;
     Done.visible := True;
end;

procedure TForm1.DoneClick(Sender: TObject);
begin
     if MessageDlg('Are you using MAPI?', mtcustom, [mbYes, mbNo], 0) = mrYes
     then                                        {MAPI enabled}
     begin
         CrystalReport1.EmailCCList := CCList.Text;
         Crystalreport1.destination := 3;        {set destination of the report
                                                  to MAPI                      }
     end
     else                                        {VIM enabled}
     begin
         CrystalReport1.EMailVIMBCCList := CCList.Text;
                                                 {set all other mail props
                                                  that are independant of
                                                  Email System            }
         Crystalreport1.destination := 4;        {set destination of the report
                                                  to VIM                       }
     end;
     CrystalReport1.EmailMessage := EmailMessage.Text;
     CrystalReport1.EmailSubject := Subject.Text;
     CrystalReport1.EmailToList := ToList.Text;
                                                      {hide all controls for Email}
     ToList.visible := False;
     ToListLabel.visible := False;
     CCList.visible := False;
     CCListLabel.visible := False;
     Subject.visible := False;
     SubjectLabel.visible := False;
     EmailMessage.visible := False;
     EmailMessageLabel.visible := False;
     Done.visible := False;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Application.Terminate;                      {Close the Application down}
end;

procedure TForm1.Formula2Click(Sender: TObject);
begin
     Count := 0;
     Continue := TRUE;
     repeat
                                                 {Get the user's input for
                                                  formula                 }
          FormulaString := InputBox ('Formula Passing','Formula String',
                                     'FormulaName="This is a test"');
          if FormulaString <> ' '
          then
          begin
               CrystalReport1.Formulas [Count] := FormulaString;
               if MessageDlg('Another Formula?', mtcustom, [mbYes, mbNo],
                             0) = mrYes
               then
               begin
                    Continue := TRUE;
                    Count := Count + 1;          {increment 1 place in the
                                                  array                   }
                    FormulaString := ' ';
               end
               else
               begin
                    Continue := FALSE;
                    Count := 0;                  {reset the array index}
                    FormulaString := ' ';
               end;
          end;
     until Continue = FALSE;

end;

procedure TForm1.SelectionFormula1Click(Sender: TObject);
begin
                                                 {Get the user's selection
                                                  formula                 }
     ReportSelection := InputBox ('Record Selection','Selection String',
                                  '{table.Number} = 10');
     if ReportSelection <> ' '
                                                 {Put the user's input into
                                                  the Selection formula    }
     then CrystalReport1.SelectionFormula := ReportSelection;
end;

procedure TForm1.GroupSelection1Click(Sender: TObject);
begin
                                                 {Get the user's selection
                                                  formula                 }
     GroupSelection := InputBox ('Group Selection','Selection String',
                                 '{table.Number} = 10');
     if GroupSelection <> ' '
                                                 {Put the user's input into
                                                  the Selection formula    }
     then CrystalReport1.GroupSelectionFormula := GroupSelection;
end;

procedure TForm1.Location1Click(Sender: TObject);
begin
     Count := 0;
     Continue := TRUE;
     repeat
           OpenDialog2.Execute;                  {Get the filename from the
                                                  user                     }
           CrystalReport1.Datafiles [count] := OpenDialog2.FileName;
                                                 {send the location to Crystal}
           if MessageDlg('Another Datafile?', mtcustom, [mbYes, mbNo],
                         0) = mrYes
           then
           begin
                Continue := TRUE;
                Count := Count + 1;              {increment 1 place in the
                                                  array                   }
           end
           else
           begin
                Continue := FALSE;
                Count := 0;                      {reset the array index}
           end;
     until Continue = FALSE;
end;

procedure TForm1.LogonInfo1Click(Sender: TObject);
begin
     passworddlg.visible := TRUE;               {Get the User's password and
                                                 place it in the connect
                                                 string                      }
end;

procedure TForm1.Print1Click(Sender: TObject);
begin
     CrystalReport1.Action := 1;                 {Run Report}
end;

end.
